> For the complete documentation index, see [llms.txt](https://docs.sled.so/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.sled.so/snowflake_connection/grant-permissions-on-future-tables.md).

# Grant permissions on future tables

The following code block grants future permission to the role `snowboard_role` on all future tables and views in a database. This is needed for older Snowflake installations that only support future grants on the schema level.

```sql
EXECUTE IMMEDIATE $$
-- TODO CHANGE database_name
DECLARE
  database_name TEXT := 'EXAMPLE_DB';
  log_text TEXT;
  grant_statement TEXT;
  schema_name TEXT;
  res_schemas RESULTSET;
  res resultset;
BEGIN
  log_text := 'START - ';
  grant_statement := 'show schemas in database ' || :database_name;
  res_schemas := (EXECUTE IMMEDIATE :grant_statement);
  FOR record IN res_schemas DO
    IF (record."name" != 'INFORMATION_SCHEMA') THEN
      schema_name := :database_name || '.' || record."name";
      grant_statement := 'grant select, references on future tables in schema ' || schema_name || ' to role snowboard_role; ';
      res := (EXECUTE IMMEDIATE :grant_statement);
      grant_statement := 'grant select, references on future views in schema ' || schema_name || ' to role snowboard_role; ';
      res := (EXECUTE IMMEDIATE :grant_statement);
      log_text := log_text || record."name" || ' GRANTED - ';
    END IF;
  END FOR;
  RETURN log_text;
END;
$$;

```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.sled.so/snowflake_connection/grant-permissions-on-future-tables.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
